#ifndef __BT848__
#define __BT848__


const int DTSTATUS      = 0x00;
const int IFORM         = 0x04;
const int TDEC          = 0x08;
const int E_CROP        = 0x0C;
const int O_CROP        = 0x8C;
const int E_VDELAY_LO   = 0x10;
const int O_VDELAY_LO   = 0x90;
const int E_VACTIVE_LO  = 0x14;
const int O_VACTIVE_LO  = 0x94;
const int E_DELAY_LO    = 0x18;
const int O_DELAY_LO    = 0x98;
const int E_HACTIVE_LO  = 0x1C;
const int O_HACTIVE_LO  = 0x9C;
const int E_HSCALE_HI   = 0x20;
const int O_HSCALE_HI   = 0xA0;
const int E_HSCALE_LO   = 0x24;
const int O_HSCALE_LO   = 0xA4;
const int BRIGHT        = 0x28;
const int E_CONTROL     = 0x2C;
const int O_CONTROL     = 0xAC;
const int CONTRAST_LO   = 0x30;
const int SAT_U_LO      = 0x34;
const int SAT_V_LO      = 0x38;
const int HUE           = 0x3C;
const int E_SCLOOP      = 0x40;
const int O_SCLOOP      = 0xC0;
const int OFORM         = 0x48;
const int E_VSCALE_HI   = 0x4C;
const int O_VSCALE_HI   = 0xCC;
const int E_VSCALE_LO   = 0x50;
const int O_VSCALE_LO   = 0xD0;
const int TEST          = 0x54;
const int ADELAY        = 0x60;
const int BDELAY        = 0x64;
const int ADC           = 0x68;
const int E_VTC         = 0x6C;
const int O_VTC         = 0xEC;
const int SRESET        = 0x7C;
const int COLOR_FMT     = 0xD4;
const int COLOR_CTL     = 0xD8;
const int CAP_CTL       = 0xDC;
const int VBI_PACK_SIZE = 0xE0;
const int VBI_PACK_DEL  = 0xE4;
const int PLL_F_LO      = 0xF0;
const int PLL_F_HI      = 0xF4;
const int PLL_XCI       = 0xF8;
const int FCAP          = 0xE8;
const int INT_STAT      = 0x100;
const int INT_MASK      = 0x104;
const int GPIO_DMA_CTL  = 0x10C;
const int I2C           = 0x110;
const int RISC_STRT_ADD = 0x114;
const int GPIO_OUT_EN   = 0x118;
const int GPIO_REG_INP  = 0x11C;
const int RISC_COUNT    = 0x120;
const int GPIO_DATA     = 0x200;

const int RGB32   = 0x00;
const int RGB24   = 0x11;
const int RGB16   = 0x22;
const int RGB15   = 0x33;
const int YUY2    = 0x44;
const int BTYUV   = 0x55;
const int Y8      = 0x66;
const int RGB8    = 0x77;
const int YUY2P   = 0x88;
const int BTYUVP  = 0x99;
const int RAW8    = 0xee;

// RISC Befehle
const int RESYNCEVENTSTART  = 0x8C00800C;
const int RESYNCPACKEDDATA  = 0x8C008006;
const int RESYNCPLANARDATA  = 0x8C00800E;
const int SYNCODDSTART      = 0x8C000004;
const int SYNCEVENTSTART    = 0x8C00000C;
const int JUMP              = 0x7C000000;
const int WRITE768e         = 0x1CC30300;
const int WRITE768o         = 0x1C3C0300;

const int WRITE123Y         = 0x9C000300;
const int WRITE123UVC       = 0x01800180;

const int SKIPY1            = 0xACE10300;
const int SKIPY2            = 0xACD20300;
const int SKIPY3            = 0xACC30300;
const int SKIPY4            = 0xACB40300;
const int SKIPUV            = 0x01800180;


class CBT848
{
   public:
      CBT848();
      virtual ~CBT848();

      void  InitBT();
      void  ResetBT();
      bool  BTGefunden();

   private:
      bool         ReadBT(int, unsigned int*);
      bool         WriteBT(int, unsigned int);
      unsigned int FindeAdresse(unsigned short, unsigned short);

      unsigned int nAdresseBT;
};

#endif
