#ifndef __CSYSTER__
#define __CSYSTER__


// Anzahl der Zeilen pro Bild
const int ZEILENZAHL = 287;

// Gre der Paarindizes
const int INDEXSIZE = 12000;

// Pixelmode der Grafikkarte
const int GRAFIKMODE_RGB15 = 0;
const int GRAFIKMODE_RGB16 = 1;

// Seb 31/10/98
const int GRAFIKMODE_RGB24 = 2;
// Seb 31/10/98

class CSyster
{
	public:
		CSyster(int);
		virtual ~CSyster();

		//void FindLineOrder(unsigned char**, int*, int, bool);
		void FindLineOrder(unsigned char *, int*, int, bool);
		bool FehlerStatus();
    int FindBlackLine(int**,int);

		virtual void DecodeColor(int**, int*, int*, int, int, int, int, int, bool) = 0;

 	  short *m_pYUV2RGBTabelle;

	//private:
	 public:
      bool BaueIndex();
		void BerechnePermutation(int, int*);
      int  FindPalPlus(int**, int);
      bool LeseIndexDatei();
      bool LeseKeyDatei();
		void PaarMerken(int);
		int  PaarBewerten(int);
      bool SchreibeIndexDatei();
		int  SucheKey(int, bool);

      // Flag ob die Initialisierung geklappt hat
      bool     bError;

		// Aus dieser Tabelle wird die Permutation errechnet
		//char	   pKey[256];

		// Jede Mglichkeit der Zeilenpermutation
		//short   *pKombinationen;
		int      nPaarIndexAnzahl;
		int      nPaarIndex[INDEXSIZE];
		//int      nZeilenPaarKorrelation[INDEXSIZE];

      // Anzahl der Zeilen die getestet werden
      //int      nTestzeilen;

		int	   nAnzahlPaare;
		int     *nPaarNummer;
		int     *nPaarDanach;
		int     *nPaarDavor;
		int     *nPaarTreffer;

};


class CYVUSyster : public CSyster
{
	public:
	   CYVUSyster(int);
		virtual ~CYVUSyster();

		virtual void DecodeColor(int**, int*, int*, int, int, int, int, int, bool);
};


class CYVUSysterSecam : public CSyster
{
	public:
	   CYVUSysterSecam(int);
		virtual ~CYVUSysterSecam();

		virtual void DecodeColor(int**, int*, int*, int, int, int, int, int, bool);
};


class CRGBSyster : public CSyster
{
	public:
	   CRGBSyster(int, int);
		virtual ~CRGBSyster();

      void BaueYUV2RGBTabelle(int);
		virtual void DecodeColor(int**, int*, int*, int, int, int, int, int, bool);

   private:
     // Tabelle fr die Farbkorrektur

		 short *m_pYUV2RGBTabelle;
};


class CRGBSysterSecam : public CSyster
{
	public:
	   CRGBSysterSecam(int, int);
		virtual ~CRGBSysterSecam();

      void BaueYUV2RGBTabelle(int);
		virtual void DecodeColor(int**, int*, int*, int, int, int, int, int, bool);

      // Tabelle fr die Farbkorrektur
		 // Seb 01/11/98
		 short *m_pYUV2RGBTabelle;
     //int *m_pYUV2RGBTabelle;
		 // Seb 01/11/98
};
#endif