#pragma warning(disable: 4100 4201 4514)

#include <windows.h>
#include <stdio.h>

#include "Decode.h"
#include "StartDialog.h"
#include "resource.h"


#ifdef DIRECTX

enum DISPLAY { MODE_ERSTER       = 0,
               MODE_640_480_YUY12 = MODE_ERSTER,
							 MODE_400_300_YUY2,
               MODE_640_480_YUY2,
               MODE_800_600_YUY2,
               MODE_640_480_YUY2_HQ,
               MODE_800_600_YUY2_HQ,
               MODE_400_300_RGB15,
               MODE_640_480_RGB15,
               MODE_400_300_RGB16,
               MODE_640_480_RGB16,
							 MODE_640_480_RGB24,
               MODE_ANZAHL
             };

const char pDisplayText[][20] = { "640x480 YU12",
																	"400*300 YUY2",
                                  "640*480 YUY2",
                                  "800*600 YUY2",
                                  "640*480 YUY2 HQ",
                                  "800*600 YUY2 HQ",
                                  "400*300 RGB15",
                                  "640*480 RGB15",
                                  "400*300 RGB16",
                                  "640*480 RGB16",
																	"640*480 RGB24"
                                };
#else

enum DISPLAY { MODE_ERSTER        = 0,
							 MODE_640_480_YUY12 = MODE_ERSTER,
               MODE_400_300_RGB15,
               MODE_640_480_RGB15,
							 MODE_640_480_RGB24,
               MODE_ANZAHL
             };

const char pDisplayText[][20] = { "640*480 YUY12",
																	"400*300 RGB15",
                                  "640*480 RGB15",
                                  "640*480 RGB24"
                                };
#endif


const char pAppTitle[]      = "MoreTV";
const char pIniDatei[]      = "\\MoreTV.ini";
const char pTestzeilen[]    = "Testzeilen";
const char pErsteZeile[]    = "ErsteZeile";
const char pLetzteZeile[]   = "LetzteZeile";
const char pDisplayMode[]   = "DisplayMode";
const char pOptimierungBT[] = "OptimierungBT";
const char pStatistik[]	    = "Statistik";
const char pPalPlus[]		 = "PALplus";
const char pSecam[]			 = "Secam";


bool  CStartDialog::m_bDetectFormat;  //Xetra
bool  CStartDialog::m_bEnableBT;
bool  CStartDialog::m_bOptimierungBT;
bool  CStartDialog::m_bPalPlus;
bool  CStartDialog::m_bSecam;
bool  CStartDialog::m_bStatistic;
int   CStartDialog::m_nTestZeilen;
int   CStartDialog::m_nErsteZeile;
int   CStartDialog::m_nLetzteZeile;
int   CStartDialog::m_nPixelMode;
int   CStartDialog::m_nScreenWidth;
int   CStartDialog::m_nScreenHeight;
int   CStartDialog::m_nZeilenAusgabe;
int   CStartDialog::m_nVideoWidth;
int   CStartDialog::m_nDisplayMode;


CStartDialog::CStartDialog()
{
}


CStartDialog::~CStartDialog()
{
}


int CStartDialog::DoModal
(
   HINSTANCE   hInstance,
   bool        bEnableBT
)
{
   m_bEnableBT = bEnableBT;
	return DialogBox(hInstance, MAKEINTRESOURCE(IDD_KONFIGURATION), HWND_DESKTOP, (DLGPROC)StartDialog);
}


bool CStartDialog::GetDetectFormat()  // Xetra
{
    return m_bDetectFormat;
}

bool CStartDialog::SetDetectFormat ( bool bDetectFormat )
{
	m_bDetectFormat = bDetectFormat;
	return m_bDetectFormat;
}

bool CStartDialog::Secam()
{
   return m_bSecam;
}


bool CStartDialog::OptimierungBT()
{
   return m_bOptimierungBT;
}


int CStartDialog::PixelMode()
{
   return m_nPixelMode;
}


bool CStartDialog::PalPlus()
{
   return m_bPalPlus;
}


bool CStartDialog::Statistic()
{
   return m_bStatistic;
}


int CStartDialog::TestZeilen()
{
   return m_nTestZeilen;
}


int CStartDialog::VideoWidth()
{
   return m_nVideoWidth;
}


int CStartDialog::ScreenWidth()
{
   return m_nScreenWidth;
}


int CStartDialog::ScreenHeight()
{
   return m_nScreenHeight;
}


int CStartDialog::ZeilenAusgabe()
{
   return m_nZeilenAusgabe;
}


int CStartDialog::GetErsteZeile()
{
   return m_nErsteZeile;
}


int CStartDialog::GetLetzteZeile()
{
   return m_nLetzteZeile;
}


int CStartDialog::SetErsteZeile
(
   int nErsteZeile
)
{
   m_nErsteZeile = nErsteZeile;
   CheckParameter();
   return m_nErsteZeile;
}


int CStartDialog::SetLetzteZeile
(
   int nLetzteZeile
)
{
   m_nLetzteZeile = nLetzteZeile;
   CheckParameter();
   return m_nLetzteZeile;
}


// Parameter aus der INI-Datei einlesen
void CStartDialog::ReadINI()
{
   char	pValue[80];
   char pPath[_MAX_PATH];

   GetCurrentDirectory(sizeof(pPath), pPath);
   lstrcat(pPath, pIniDatei);

   // Anzahl der zu Testenden Zeilen
	GetPrivateProfileString(pAppTitle, pTestzeilen, "16", pValue, sizeof(pValue), pPath);
   m_nTestZeilen = atoi(pValue);

	// Erste und letzte sichtbare Zeile
	GetPrivateProfileString(pAppTitle, pErsteZeile, "2", pValue, sizeof(pValue), pPath);
	m_nErsteZeile = atoi(pValue);

	GetPrivateProfileString(pAppTitle, pLetzteZeile, "285", pValue, sizeof(pValue), pPath);
	m_nLetzteZeile = atoi(pValue);

   // DisplayMode
	GetPrivateProfileString(pAppTitle, pDisplayMode, "0", pValue, sizeof(pValue), pPath);
	m_nDisplayMode = atoi(pValue);

	// Statistik
	GetPrivateProfileString(pAppTitle, pStatistik, "0", pValue, sizeof(pValue), pPath);
	if(strcmp(pValue, "0") == 0)
		m_bStatistic = false;
   else
      m_bStatistic = true;

	// OptimierungBT
	GetPrivateProfileString(pAppTitle, pOptimierungBT, "1", pValue, sizeof(pValue), pPath);
	if(strcmp(pValue, "0") == 0)
		m_bOptimierungBT = false;
   else
      m_bOptimierungBT = true;

	// Secam lesen
	GetPrivateProfileString(pAppTitle, pSecam, "0", pValue, sizeof(pValue), pPath);
	if(strcmp(pValue, "0") == 0)
		m_bSecam = false;
   else
      m_bSecam = true;

   // PALplus
	GetPrivateProfileString(pAppTitle, pPalPlus, "1", pValue, sizeof(pValue), pPath);
	if(strcmp(pValue, "0") == 0)
		m_bPalPlus = false;
   else
      m_bPalPlus = true;
}


void CStartDialog::FormatSpeichern()
{
	char	pValue[80];
   char pPath[_MAX_PATH];

   GetCurrentDirectory(sizeof(pPath), pPath);
   lstrcat(pPath, pIniDatei);

	sprintf(pValue, "%d", m_nErsteZeile);
	WritePrivateProfileString(pAppTitle, pErsteZeile, pValue, pPath);

	sprintf(pValue, "%d", m_nLetzteZeile);
	WritePrivateProfileString(pAppTitle, pLetzteZeile, pValue, pPath);
}


// Parameter in der INI-Datei abspeichern
void CStartDialog::WriteINI()
{
	char pValue[80];
   char pPath[_MAX_PATH];

   GetCurrentDirectory(sizeof(pPath), pPath);
   lstrcat(pPath, pIniDatei);

	sprintf(pValue, "%d", m_nTestZeilen);
	WritePrivateProfileString(pAppTitle, pTestzeilen, pValue, pPath);

	sprintf(pValue, "%d", m_nErsteZeile);
	WritePrivateProfileString(pAppTitle, pErsteZeile, pValue, pPath);

	sprintf(pValue, "%d", m_nLetzteZeile);
	WritePrivateProfileString(pAppTitle, pLetzteZeile, pValue, pPath);

	sprintf(pValue, "%d", m_nDisplayMode);
   WritePrivateProfileString(pAppTitle, pDisplayMode, pValue, pPath);

	if(m_bStatistic == false)
	   WritePrivateProfileString(pAppTitle, pStatistik, "0", pPath);
	else
		WritePrivateProfileString(pAppTitle, pStatistik, "1", pPath);

	if(m_bOptimierungBT == false)
	   WritePrivateProfileString(pAppTitle, pOptimierungBT, "0", pPath);
	else
		WritePrivateProfileString(pAppTitle, pOptimierungBT, "1", pPath);

	if(m_bSecam == false)
	   WritePrivateProfileString(pAppTitle, pSecam, "0", pPath);
	else
		WritePrivateProfileString(pAppTitle, pSecam, "1", pPath);

	if(m_bPalPlus == false)
	   WritePrivateProfileString(pAppTitle, pPalPlus, "0", pPath);
	else
		WritePrivateProfileString(pAppTitle, pPalPlus, "1", pPath);
}


// Parameter berprfen und eventuell korrigieren
void CStartDialog::CheckParameter()
{
   // Anzahl der Testzeilen testen
   if(m_nTestZeilen < 8)
      m_nTestZeilen = 8;

   if(m_nTestZeilen > 82)
      m_nTestZeilen = 82;

	// Erste und letzte sichtbare Zeile testen
	if( m_nErsteZeile < 0 ||
		 m_nErsteZeile >= m_nLetzteZeile ||
		 m_nLetzteZeile > ZEILENZAHL
	  )
	{
		m_nErsteZeile = 0;
		m_nLetzteZeile = ZEILENZAHL;
	}

   // Displaymode
   if( m_nDisplayMode < MODE_ERSTER ||
       m_nDisplayMode >= MODE_ANZAHL
     )
      m_nDisplayMode = MODE_ERSTER;

   // Nur zulassen wenn BT gefunden
   if(m_bEnableBT == false)
      m_bOptimierungBT = false; 
}


// Dialogelemente auslesen
void CStartDialog::GetDialogData
(
   HWND hWnd
)
{
	char pValue[80];

	GetWindowText(GetDlgItem(hWnd, IDC_TESTZEILEN), pValue, sizeof(pValue));
   m_nTestZeilen = atoi(pValue);

	GetWindowText(GetDlgItem(hWnd, IDC_ERSTE_ZEILE), pValue, sizeof(pValue));
	m_nErsteZeile = atoi(pValue);

	GetWindowText(GetDlgItem(hWnd, IDC_LETZTE_ZEILE), pValue, sizeof(pValue));
	m_nLetzteZeile = atoi(pValue);

   m_nDisplayMode = SendDlgItemMessage(hWnd, IDC_DISPLAYMODE, CB_GETCURSEL, 0, 0);
   switch(m_nDisplayMode)
   {
#ifdef DIRECTX
      case MODE_400_300_YUY2:
		   m_nScreenWidth   = 400;
		   m_nScreenHeight  = 300;
		   m_nVideoWidth    = 384;
         m_nZeilenAusgabe = ZEILENZAHL;
         m_nPixelMode     = PIXELMODE_YUY2;
      break;

      case MODE_640_480_YUY2:
		   m_nScreenWidth   = 640;
		   m_nScreenHeight  = 480;
		   m_nVideoWidth    = 384;
         m_nZeilenAusgabe = ZEILENZAHL;
         m_nPixelMode     = PIXELMODE_YUY2;
      break;

      case MODE_800_600_YUY2:
		   m_nScreenWidth   = 800;
		   m_nScreenHeight  = 600;
		   m_nVideoWidth    = 384;
         m_nZeilenAusgabe = ZEILENZAHL;
         m_nPixelMode     = PIXELMODE_YUY2;
      break;

      case MODE_640_480_YUY2_HQ:
		   m_nScreenWidth   = 640;
		   m_nScreenHeight  = 480;
		   m_nVideoWidth    = 620;
         m_nZeilenAusgabe = ZEILENZAHL;
         m_nPixelMode     = PIXELMODE_YUY2;
      break;

      case MODE_800_600_YUY2_HQ:
		   m_nScreenWidth   = 800;
		   m_nScreenHeight  = 600;
		   m_nVideoWidth    = 768;
         m_nZeilenAusgabe = ZEILENZAHL;
         m_nPixelMode     = PIXELMODE_YUY2;
      break;

      case MODE_400_300_RGB16:
		   m_nScreenWidth   = 400;
		   m_nScreenHeight  = 300;
		   m_nVideoWidth    = 384;
         m_nZeilenAusgabe = ZEILENZAHL;
         m_nPixelMode     = PIXELMODE_RGB16;
      break;

      case MODE_640_480_RGB16:
		   m_nScreenWidth   = 640;
		   m_nScreenHeight  = 480;
		   m_nVideoWidth    = 620;
         m_nZeilenAusgabe = 464;
         m_nPixelMode     = PIXELMODE_RGB16;
      break;
#endif
      case MODE_640_480_YUY12:
		   m_nScreenWidth   = 400;
		   m_nScreenHeight  = 300;
		   m_nVideoWidth    = 352;//352
         m_nZeilenAusgabe = 287;
         m_nPixelMode     = PIXELMODE_RGB15;
      break;

      case MODE_400_300_RGB15:
		   m_nScreenWidth   = 400;
		   m_nScreenHeight  = 300;
		   m_nVideoWidth    = 384;
         m_nZeilenAusgabe = ZEILENZAHL;
         m_nPixelMode     = PIXELMODE_RGB15;
      break;

      case MODE_640_480_RGB15:
		   m_nScreenWidth   = 640;
		   m_nScreenHeight  = 480;
		   m_nVideoWidth    = 620;
         m_nZeilenAusgabe = 464;
         m_nPixelMode     = PIXELMODE_RGB15;
      break;

      default:
		   m_nScreenWidth   = 400;
		   m_nScreenHeight  = 300;
		   m_nVideoWidth    = 384;
         m_nZeilenAusgabe = ZEILENZAHL;
         m_nPixelMode     = PIXELMODE_YUY2;
   }

	if(BST_CHECKED == IsDlgButtonChecked(hWnd, IDC_DETECTFORMAT))  //Xetra
		m_bDetectFormat = true;
	else
		m_bDetectFormat = false;

    if(BST_CHECKED == IsDlgButtonChecked(hWnd, IDC_STATISTIK))
		m_bStatistic = true;
	else
		m_bStatistic = false;

	if(BST_CHECKED == IsDlgButtonChecked(hWnd, IDC_BT848))
		m_bOptimierungBT = true;
	else
		m_bOptimierungBT = false;

	if(BST_CHECKED == IsDlgButtonChecked(hWnd, IDC_SECAM))
		m_bSecam = true;
	else
		m_bSecam = false;

	if(BST_CHECKED == IsDlgButtonChecked(hWnd, IDC_PALPLUS))
		m_bPalPlus = true;
	else
		m_bPalPlus = false;
}


// Dialogelemente setzen
void CStartDialog::SetDialogData
(
   HWND hWnd
)
{
   char	pValue[80];

	sprintf(pValue, "%d", m_nTestZeilen);
   SetWindowText(GetDlgItem(hWnd, IDC_TESTZEILEN), pValue);

	sprintf(pValue, "%d", m_nErsteZeile);
	SetWindowText(GetDlgItem(hWnd, IDC_ERSTE_ZEILE), pValue);

	sprintf(pValue, "%d", m_nLetzteZeile);
	SetWindowText(GetDlgItem(hWnd, IDC_LETZTE_ZEILE), pValue);

   // Liste mit allen Ausgabeformaten in die Listbox schreiben
   for(int nDisplayMode=MODE_ERSTER; nDisplayMode<MODE_ANZAHL; nDisplayMode++)
      SendDlgItemMessage(hWnd, IDC_DISPLAYMODE, CB_ADDSTRING, 0, (LPARAM)pDisplayText[nDisplayMode]);

   // Aktuelles Ausgabeformat selektieren
   if(CB_ERR == SendDlgItemMessage(hWnd, IDC_DISPLAYMODE, CB_SETCURSEL, m_nDisplayMode, 0))
      SendDlgItemMessage(hWnd, IDC_DISPLAYMODE, CB_SETCURSEL, 0, 0);

    CheckDlgButton(hWnd, IDC_DETECTFORMAT, m_bDetectFormat);  // Xetra	
    CheckDlgButton(hWnd, IDC_STATISTIK, m_bStatistic);
    CheckDlgButton(hWnd, IDC_SECAM, m_bSecam);
	CheckDlgButton(hWnd, IDC_PAL, !m_bSecam);
	CheckDlgButton(hWnd, IDC_PALPLUS, m_bPalPlus);
	

	// OptimierungBT
   if(m_bEnableBT == false)
   {
      CheckDlgButton(hWnd, IDC_BT848, false);
      EnableWindow(GetDlgItem(hWnd, IDC_BT848), false);
   }
   else
   {
	   CheckDlgButton(hWnd, IDC_BT848, m_bOptimierungBT);
   }
}


BOOL CALLBACK CStartDialog::StartDialog
(
   HWND     hWnd,
   UINT     uMessage,
   WPARAM   wParam,
   LPARAM   lParam
)
{
	switch(uMessage)
	{
		case WM_INITDIALOG:
         ReadINI();
         SetDialogData(hWnd);

    		return TRUE;
 		break;

		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case IDC_SPEICHERN:
               GetDialogData(hWnd);
               CheckParameter();
               WriteINI();

					return TRUE;
				break;

				case IDOK:
               GetDialogData(hWnd);
               CheckParameter();

					EndDialog(hWnd, LOWORD(wParam));
					return TRUE;
				break;

				case IDCANCEL:
					EndDialog(hWnd, LOWORD(wParam));
					return TRUE;
            break;
			}
		break;
	}

	return FALSE;
}
