#ifndef __BT848__
#define __BT848__


#include "hwiodef.h"


class CBT848
{
   public:
      CBT848();
      virtual ~CBT848();

      bool BTGefunden();

      int HoleFarbe();

      int SetzeFarbe
      (
         int nCroma
      );

      void InitBTxx();
      void InitBTxxHQ();

      int HoleHelligkeit();

      int SetzeHelligkeit
      (
         int nBright
      );

      int HoleKanal();

      void SetzeKanal
      (
         int   nKanal,
         char *pName
      );

      int HoleKontrast();

      int SetzeKontrast
      (
         int nLuma
      );

      void SetzeTuner
      (
         int nTuner
      );

      void SetzeTVKarte
      (
         int nTVCard
      );

      void ResetBT();

   private:
      void  BaueProgramm();
      bool  FindeAdresse();
      bool  ReadBT(int, DWORD*);
      bool  ReadI2C(DWORD, DWORD*);
      bool  WriteBT(int, DWORD);
      bool  WriteI2C(DWORD, DWORD);

      PPCIGetHardwareResources m_fnGetHardwareResources;
      PIsDriverOpened          m_fnIsDriverOpened;
      PMemoryUnmap             m_fnMemoryUnmap;
      PMemoryMap               m_fnMemoryMap;
      PMemoryRead              m_fnMemoryRead;
      PMemoryWrite             m_fnMemoryWrite;

      int       m_nTuner;
      int       m_nTVCard;
      int       m_nKanal;
      bool      m_bError;
      DWORD     m_dwPhysicalAddress;
      DWORD     m_dwMemoryLength;
      DWORD     m_dwIrqNumber;
      DWORD     m_dwMemoryBase;
      HINSTANCE m_hLibrary;
};

#endif
