#pragma warning(disable: 4201 4514)

#include <windows.h>
#include <stdio.h>
#include <stdarg.h>
#include <time.h>

#include "Debug.h"
#include "Vidcap.h"
#include "resource.h"


const char pDebug[]    = "Debug";
const char pLogDatei[] = "MoreTV.log";

FILE      *sFile = NULL;
HINSTANCE  hInst = NULL;


void DebugInit(HINSTANCE hInstance)
{
   char           pTime[9];
   char           pValue[2];
   char           pPath[_MAX_PATH];
   OSVERSIONINFO  sOSVersion;

   hInst = hInstance;

   GetCurrentDirectory(sizeof(pPath), pPath);
   lstrcat(pPath, pIniDatei);
   GetPrivateProfileString(pAppTitle, pDebug, "0", pValue, sizeof(pValue), pPath);
   WritePrivateProfileString(pAppTitle, pDebug, pValue, pPath);

   if(strcmp(pValue, "1") == 0)
   {
      sFile = fopen(pLogDatei, "a+");
      if(sFile == NULL)
      {
         MessageBox(IDS_ERR_OPEN_LOG);
         return;
      }

      _strtime(pTime);
      DebugString("Start um %s", pTime);

      DebugString("%s", pVersion);

      sOSVersion.dwOSVersionInfoSize = sizeof(sOSVersion);
      GetVersionEx(&sOSVersion);

      switch(sOSVersion.dwPlatformId)
      {
         case VER_PLATFORM_WIN32_NT:
            DebugString( "Windows NT %d.%d  build %d %s",
                         sOSVersion.dwMajorVersion,
                         sOSVersion.dwMinorVersion,
                         sOSVersion.dwBuildNumber,
                         sOSVersion.szCSDVersion
                       );
         break;

         case VER_PLATFORM_WIN32_WINDOWS:
            DebugString( "Windows 9x build %d %s",
                         LOWORD(sOSVersion.dwBuildNumber),
                         sOSVersion.szCSDVersion
                       );
         break;

         default:
            DebugString("???");
      }
   }
}


void DebugEnd()
{
   char pTime[9];

   if(sFile != NULL)
   {
      _strtime(pTime);
      DebugString("Stop um %s\n", pTime);

      fclose(sFile);
   }
}


void DebugString(const char *pFormat, ...)
{
   va_list pArg;
   char    pMessage[400];

   if(sFile == NULL)
      return;

   va_start(pArg, pFormat);
   vsprintf(pMessage, pFormat, pArg);
   va_end(pArg);
   
   fprintf(sFile, "%s\n", pMessage);
   fflush(sFile);
}


int MessageBox(UINT nMessage)
{
   char pMessage[400];

   LoadString(hInst, nMessage, pMessage, sizeof(pMessage));

   DebugString(pMessage);
   return MessageBox(HWND_DESKTOP, pMessage, pAppTitle,  MB_OK | MB_ICONEXCLAMATION | MB_SYSTEMMODAL);
}


int MessageBox(const char *pFormat, ...)
{
   va_list pArg;
   char    pMessage[400];

   va_start(pArg, pFormat);
   vsprintf(pMessage, pFormat, pArg);
   va_end(pArg);

   DebugString(pMessage);
   return MessageBox(HWND_DESKTOP, pMessage, pAppTitle,  MB_OK | MB_ICONEXCLAMATION | MB_SYSTEMMODAL);
}
