#pragma warning(disable: 4201 4514)

#include <windows.h>
#include <stdio.h>
#include <ddraw.h>
#include <vfw.h>

#include "Syster.h"
#include "Konfig.h"
#include "Vidcap.h"
#include "Debug.h"
#include "resource.h"


const char pAustastung[]    = "Austastung";
const char pCaptureDevice[] = "CaptureDevice";
const char pDisplayMode[]   = "DisplayMode";
const char pErsteZeile[]    = "ErsteZeile";
const char pFarbe[]         = "Farbe";
const char pHelligkeit[]    = "Helligkeit";
const char pKontrast[]      = "Kontrast";
const char pLetzteZeile[]   = "LetzteZeile";
const char pOptimierungBT[] = "OptimierungBT";
const char pPriority[]      = "Priority";
const char pPALplus[]       = "PALplus";
const char pStatistik[]     = "Statistik";
const char pSchwarzeZeile[] = "SchwarzeZeile";
const char pSecam[]         = "Secam";
const char pStation[]       = "Station%d";
const char pTestzeilen[]    = "Testzeilen";
const char pTuner[]         = "Tuner";
const char pTVCard[]        = "TVKarte";
const char pKonfigKlasse[]  = "KonfigKlasse";

// Sound by Satan
const char pSound[]			= "Sound";
const char pSoundMMX[]      = "Sound MMX";
const char pSoundFilter[]   = "Sound Filter";


struct Aufloesung
{
   char  pName[20];
   bool  bMMX;
   bool  bOverlay;
   bool  bWindow;
   bool  bActive;
   int   nScreenWidth;
   int   nScreenHeight;
   int   nVideoWidth;
   int   nVideoHeight;
   int   nZeilenAusgabe;
   DWORD dwCooperativeLevel;
}
sAufloesung[] =
{
  { "400*300 YUY2",      false, true,  false, false, 400, 300, 384, 576, 287, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN },
  { "640*480 YUY2",      false, true,  false, false, 640, 480, 384, 576, 287, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN },
  { "800*600 YUY2",      false, true,  false, false, 800, 600, 384, 576, 287, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN },
  { "400*300 YUY2 HQ",   true,  true,  false, false, 400, 300, 384, 576, 287, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN },
  { "640*480 YUY2 HQ",   true,  true,  false, false, 640, 480, 384, 576, 287, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN },
  { "800*600 YUY2 HQ",   true,  true,  false, false, 800, 600, 768, 576, 287, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN },
  { "400*300 RGB",       false, false, false, false, 400, 300, 400, 576, 300, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN },
  { "512*384 RGB",       false, false, false, false, 512, 384, 512, 576, 384, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN },
  { "640*400 RGB",       false, false, false, false, 640, 400, 640, 576, 400, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN },
  { "640*480 RGB",       false, false, false, false, 640, 480, 640, 576, 480, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN },
  { "720*480 RGB",       false, false, false, false, 720, 480, 720, 576, 480, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN },
  { "720*576 RGB",       false, false, false, false, 720, 576, 720, 576, 576, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN },
  { "800*600 RGB",       false, false, false, false, 800, 600, 768, 576, 600, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN },
  { "400*300 RGB HQ",    true,  false, false, false, 400, 300, 400, 576, 300, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN },
  { "512*384 RGB HQ",    true,  false, false, false, 512, 384, 512, 576, 384, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN },
  { "640*400 RGB HQ",    true,  false, false, false, 640, 400, 640, 576, 400, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN },
  { "640*480 RGB HQ",    true,  false, false, false, 640, 480, 640, 576, 480, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN },
  { "720*480 RGB HQ",    true,  false, false, false, 720, 480, 720, 576, 480, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN },
  { "720*576 RGB HQ",    true,  false, false, false, 720, 576, 720, 576, 576, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN },
  { "800*600 RGB HQ",    true,  false, false, false, 800, 600, 768, 576, 600, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN },
  { "Windowed",        false, true,  true,  true,  384, 287, 384, 576, 287, DDSCL_NORMAL                       },
  { "Windowed HQ",     true,  true,  true,  true,  384, 287, 384, 576, 287, DDSCL_NORMAL                       },
  { "800*600 Erazor",    false, true,  false, false, 800, 600, 704, 576, 287, DDSCL_NORMAL                       },
  { "800*600 Erazor HQ", true,  true,  false, false, 800, 600, 704, 576, 287, DDSCL_NORMAL                       }
};

const int ANZAHL_AUFLOESUNG = (sizeof(sAufloesung) / sizeof(Aufloesung));


const struct Tuner
{
   int  nID;
   char pName[20];
}
sTuner[] =
{
  { TEMIC_PAL_B_G,   "Temic PAL B/G"   },
  { TEMIC_PAL_I,     "Temic PAL I"     },
  { PHILIPS_PAL_B_G, "Philips PAL B/G" },
  { PHILIPS_PAL_I,   "Philips PAL I"   },
  { PHILIPS_SECAM,   "Philips SECAM"   }
};

const int ANZAHL_TUNER = (sizeof(sTuner) / sizeof(Tuner));


const struct TVCard
{
   int  nID;
   char pName[20];
}
sTVCard[] =
{
  { KEINE,         "None"            },
  { HAUPPAUGE_848, "Hauppauge BT848" },
  { HAUPPAUGE_878, "Hauppauge BT878" },
  { MIRO_PCTV,     "Miro PCTV"       },
};

const int ANZAHL_TVCARD = (sizeof(sTVCard) / sizeof(TVCard));


// Anzahl der Videoquellen
const int ANZAHL_DRIVERS = 10;


CKonfig::CKonfig
(
   CDirectDraw *pDirectDraw
)
{
   m_bHideDialog    = false;
   m_bOverlay       = false;
   m_bEnableBT      = false;
   m_bOptimierungBT = true;
   m_bPALplus       = true;
   m_bPriority      = false;
   m_bSchwarzeZeile = false;
   m_bSecam         = false;
   m_bStatistic     = false;
   m_bAustastung    = true;
   m_nTestZeilen    = 16;
   m_nErsteZeile    = 2;
   m_nLetzteZeile   = ZEILENZAHL-2;
   m_nTuner         = 2;
   m_nTVCard        = 0;
   m_nDisplayMode   = 4;
   m_nCaptureDevice = 0;

   // Sound by Satan
   m_bSound			= true;
   m_bSoundMMX		= true;
   m_bSoundFilter	= true;


   // Werden Overlays untersttzt
   if(DDCAPS_OVERLAY & pDirectDraw->GetCaps())
      m_bOverlay = true;
   else
      m_bOverlay = false;

   // Welche Auflsungen werden untersttzt?
   for(int nDisplayMode=0; nDisplayMode<ANZAHL_AUFLOESUNG; nDisplayMode++)
   {
		// Der Fenstermodus sitzt bereits auf true
      if(true == pDirectDraw->IsDisplayMode( sAufloesung[nDisplayMode].nScreenWidth,
                                             sAufloesung[nDisplayMode].nScreenHeight,
                                             SURFACE_BITCOUNT
                                           )
        )
      {
         sAufloesung[nDisplayMode].bActive = true;
      }
   }
}


CKonfig::~CKonfig()
{
}


int CKonfig::DoModal
(
   HINSTANCE hInstance,
   bool      bEnableBT,
   bool      bHideDialog
)
{
   m_bEnableBT = bEnableBT;
	m_bHideDialog = bHideDialog;
   return DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_KONFIGURATION), HWND_DESKTOP, (DLGPROC)KonfigDialog, (LPARAM)this);
}


int CKonfig::FarbeLesen()
{
   return GetProfileInt(pFarbe, 254);
}


void CKonfig::FarbeSpeichern
(
   int nFarbe
)
{
   SetProfileInt(pFarbe, nFarbe);
}


bool CKonfig::GetAustastung()
{
   return m_bAustastung;
}


int CKonfig::GetCaptureDevice()
{
   return m_nCaptureDevice;
}


DWORD CKonfig::GetCooperativeLevel()
{
   return sAufloesung[m_nDisplayMode].dwCooperativeLevel;
}


int CKonfig::GetErsteZeile()
{
   return m_nErsteZeile;
}


bool CKonfig::GetFensterMode()
{
   return sAufloesung[m_nDisplayMode].bWindow;
}


int CKonfig::GetLetzteZeile()
{
   return m_nLetzteZeile;
}


bool CKonfig::GetMMX()
{
   return sAufloesung[m_nDisplayMode].bMMX;
}


bool CKonfig::GetOptimierungBT()
{
   return m_bOptimierungBT;
}


bool CKonfig::GetOverlay()
{
   return sAufloesung[m_nDisplayMode].bOverlay;
}


bool CKonfig::GetPALplus()
{
   return m_bPALplus;
}


bool CKonfig::GetPriority()
{
   return m_bPriority;
}


bool CKonfig::GetSchwarzeZeile()
{
   return m_bSchwarzeZeile;
}


int CKonfig::GetScreenHeight()
{
   return sAufloesung[m_nDisplayMode].nScreenHeight;
}


int CKonfig::GetScreenWidth()
{
   return sAufloesung[m_nDisplayMode].nScreenWidth;
}


bool CKonfig::GetSecam()
{
   return m_bSecam;
}


bool CKonfig::GetStatistic()
{
   return m_bStatistic;
}


int CKonfig::GetTestZeilen()
{
   return m_nTestZeilen;
}


int CKonfig::GetTuner()
{
   return sTuner[m_nTuner].nID;
}


int CKonfig::GetTVKarte()
{
   return sTVCard[m_nTVCard].nID;
}


int CKonfig::GetVideoHeight()
{
   return sAufloesung[m_nDisplayMode].nVideoHeight;
}


int CKonfig::GetVideoWidth()
{
   return sAufloesung[m_nDisplayMode].nVideoWidth;
}


int CKonfig::GetZeilenAusgabe()
{
   return sAufloesung[m_nDisplayMode].nZeilenAusgabe;
}


int CKonfig::HelligkeitLesen()
{
   return GetProfileInt(pHelligkeit, 128);
}


void CKonfig::HelligkeitSpeichern
(
   int nHelligkeit
)
{
   SetProfileInt(pHelligkeit, nHelligkeit);
}


int CKonfig::KanalLesen
(
   int nStation
)
{
   char pKey[80];

   sprintf(pKey, pStation, nStation);
   return GetProfileInt(pKey, 0);
}


void CKonfig::KanalSpeichern
(
   int nStation,
   int nKanal
)
{
   char pKey[80];

   sprintf(pKey, pStation, nStation);
   SetProfileInt(pKey, nKanal);
}


int CKonfig::KontrastLesen()
{
   return GetProfileInt(pKontrast, 216);
}


void CKonfig::KontrastSpeichern
(
   int nKontrast
)
{
   SetProfileInt(pKontrast, nKontrast);
}


int CKonfig::SetErsteZeile
(
   int nErsteZeile
)
{
   m_nErsteZeile = nErsteZeile;
   CheckParameter();
   return m_nErsteZeile;
}


int CKonfig::SetLetzteZeile
(
   int nLetzteZeile
)
{
   m_nLetzteZeile = nLetzteZeile;
   CheckParameter();
   return m_nLetzteZeile;
}


bool CKonfig::GetProfileBool
(
   const char *pKey,
   bool        bDefault
)
{
   char pValue[20];
   char pPath[_MAX_PATH];

   GetCurrentDirectory(sizeof(pPath), pPath);
   lstrcat(pPath, pIniDatei);

   if(bDefault == true)
      GetPrivateProfileString(pAppTitle, pKey, "1", pValue, sizeof(pValue), pPath);
   else
      GetPrivateProfileString(pAppTitle, pKey, "0", pValue, sizeof(pValue), pPath);

   if(strcmp(pValue, "0") == 0)
      return false;
   else
      return true;
}


int CKonfig::GetProfileInt
(
   const char *pKey,
   int         nDefault
)
{
   char pValue[20];
   char pDefault[20];
   char pPath[_MAX_PATH];

   GetCurrentDirectory(sizeof(pPath), pPath);
   lstrcat(pPath, pIniDatei);

   sprintf(pDefault, "%d", nDefault);
   GetPrivateProfileString(pAppTitle, pKey, pDefault, pValue, sizeof(pValue), pPath);

   return atoi(pValue);
}


// Sound by Satan
bool CKonfig::GetSound()
{
	return m_bSound;
}


char CKonfig::GetSoundMMX()
{
	if(m_bSoundMMX)
		return 1;
	else
		return 0;
}

char CKonfig::GetSoundFilter()
{
	if(m_bSoundFilter)
		return 1;
	else
		return 0;
}


bool CKonfig::IsMMX()
{
   // Prfen ob MMX vorhanden ist
   bool bMMX = false;

   _asm
   {
      push     eax               // Register retten
      push     ebx
      push     ecx
      push     edx

		pushfd                     // Erweiterte Flags holen
		pop      eax               // In EAX speichern
      mov      ebx,eax           // In EBX speichern
      xor      eax,0x00200000    // Bit 21 negieren
      push     eax
      popfd
      pushfd                     // Erweiterte Flags holen
      pop      eax               // In EAX speichern
      xor      eax,ebx           // Wenn sich BIT 21 schreiben lt, ist EAX != 0
      je       NoMMX             // Der Befehl CPUID wird nicht untersttzt

      mov      eax,0x01          // Feature Flags anfragen
      _emit    0x0F              // 0x0F, 0xA2 CPUID Befehl
      _emit    0xA2
      test     edx,0x800000      // MMX ist vorhanden wenn Bit 23 gesetzt ist
      jz       NoMMX
      mov      byte ptr[bMMX],1

   NoMMX:
      pop      edx
      pop      ecx
      pop      ebx
      pop      eax
   }

   return bMMX;
}


void CKonfig::SetProfileBool
(
   const char *pKey,
   const bool  bValue
)
{
   char pPath[_MAX_PATH];

   GetCurrentDirectory(sizeof(pPath), pPath);
   lstrcat(pPath, pIniDatei);

   if(bValue == false)
      WritePrivateProfileString(pAppTitle, pKey, "0", pPath);
   else
      WritePrivateProfileString(pAppTitle, pKey, "1", pPath);
}


void CKonfig::SetProfileInt
(
   const char *pKey,
   const int   nValue
)
{
   char pValue[20];
   char pPath[_MAX_PATH];

   GetCurrentDirectory(sizeof(pPath), pPath);
   lstrcat(pPath, pIniDatei);

   sprintf(pValue, "%d", nValue);
   WritePrivateProfileString(pAppTitle, pKey, pValue, pPath);
}


// Parameter aus der INI-Datei einlesen
void CKonfig::ProfilLesen()
{
   // Anzahl der zu Testenden Zeilen
   m_nTestZeilen = GetProfileInt(pTestzeilen, m_nTestZeilen);

   // Erste und letzte sichtbare Zeile
   m_nErsteZeile  = GetProfileInt(pErsteZeile, m_nErsteZeile);
   m_nLetzteZeile = GetProfileInt(pLetzteZeile, m_nLetzteZeile);

   // DisplayMode
   m_nDisplayMode = GetProfileInt(pDisplayMode, m_nDisplayMode);

   // Tuner
   m_nTuner = GetProfileInt(pTuner, m_nTuner);

   // TVCard
   m_nTVCard = GetProfileInt(pTVCard, m_nTVCard);

   // Statistik
   m_bStatistic     = GetProfileBool(pStatistik,     m_bStatistic);
   m_bOptimierungBT = GetProfileBool(pOptimierungBT, m_bOptimierungBT);
   m_bSecam         = GetProfileBool(pSecam,         m_bSecam);
   m_bPALplus       = GetProfileBool(pPALplus,       m_bPALplus);
   m_bPriority      = GetProfileBool(pPriority,      m_bPriority);
   m_bSchwarzeZeile = GetProfileBool(pSchwarzeZeile, m_bSchwarzeZeile);
   m_bAustastung    = GetProfileBool(pAustastung,    m_bAustastung);

   // CaptureDevice
   m_nCaptureDevice = GetProfileInt(pCaptureDevice, m_nCaptureDevice);

   // Sound by Satan
   m_bSound			= GetProfileBool(pSound,         m_bSound);
   m_bSoundMMX		= GetProfileBool(pSoundMMX,      m_bSoundMMX);
   m_bSoundFilter	= GetProfileBool(pSoundFilter,   m_bSoundFilter);

}


void CKonfig::FormatSpeichern()
{
   SetProfileInt(pErsteZeile, m_nErsteZeile);
   SetProfileInt(pLetzteZeile, m_nLetzteZeile);
}


// Parameter in der INI-Datei abspeichern
void CKonfig::ProfilSpeichern()
{
   SetProfileInt(pTestzeilen,    m_nTestZeilen);
   SetProfileInt(pErsteZeile,    m_nErsteZeile);
   SetProfileInt(pLetzteZeile,   m_nLetzteZeile);
   SetProfileInt(pDisplayMode,   m_nDisplayMode);
   SetProfileInt(pCaptureDevice, m_nCaptureDevice);
   SetProfileInt(pTuner,         m_nTuner);
   SetProfileInt(pTVCard,        m_nTVCard);

   SetProfileBool(pStatistik,     m_bStatistic);
   SetProfileBool(pOptimierungBT, m_bOptimierungBT);
   SetProfileBool(pSecam,         m_bSecam);
   SetProfileBool(pPALplus,       m_bPALplus);
   SetProfileBool(pPriority,      m_bPriority);
   SetProfileBool(pSchwarzeZeile, m_bSchwarzeZeile);
   SetProfileBool(pAustastung,    m_bAustastung);

   //Sound by Satan
   SetProfileBool(pSound,         m_bSound);
   SetProfileBool(pSoundMMX,      m_bSoundMMX);
   SetProfileBool(pSoundFilter,   m_bSoundFilter);

}


// Parameter berprfen und eventuell korrigieren
void CKonfig::CheckParameter()
{
   // Anzahl der Testzeilen testen
   if(m_nTestZeilen < 8)
      m_nTestZeilen = 8;

   if(m_nTestZeilen > 99)
      m_nTestZeilen = 99;

   // Erste und letzte sichtbare Zeile testen
   if( m_nErsteZeile < 0 ||
       m_nErsteZeile >= m_nLetzteZeile ||
       m_nLetzteZeile > ZEILENZAHL
     )
   {
      m_nErsteZeile = 0;
      m_nLetzteZeile = ZEILENZAHL;
   }

   // Displaymode
   if( m_nDisplayMode < 0 ||
       m_nDisplayMode >= ANZAHL_AUFLOESUNG
     )
      m_nDisplayMode = ANZAHL_AUFLOESUNG-1;

   // Tuner
   if( m_nTuner< 0 ||
       m_nTuner >= ANZAHL_TUNER
     )
      m_nDisplayMode = ANZAHL_TUNER-1;

   // TVCard
   if( m_nTVCard < 0 ||
       m_nTVCard >= ANZAHL_TVCARD
     )
      m_nTVCard = ANZAHL_TVCARD-1;

   // CaptureDevice
   if( m_nCaptureDevice < 0 ||
       m_nCaptureDevice >= ANZAHL_DRIVERS
     )
      m_nCaptureDevice = 0;

   // Nur zulassen wenn BT gefunden
   if(m_bEnableBT == false)
   {
      m_bOptimierungBT = false; 
      m_nTuner = 0;
   }
}


// Dialogelemente auslesen
bool CKonfig::GetDialogData
(
   HWND hWnd
)
{
   int  nZlr;
   char pValue[80];

   GetWindowText(GetDlgItem(hWnd, IDC_TESTZEILEN), pValue, sizeof(pValue));
   m_nTestZeilen = atoi(pValue);

   GetWindowText(GetDlgItem(hWnd, IDC_ERSTE_ZEILE), pValue, sizeof(pValue));
   m_nErsteZeile = atoi(pValue);

   GetWindowText(GetDlgItem(hWnd, IDC_LETZTE_ZEILE), pValue, sizeof(pValue));
   m_nLetzteZeile = atoi(pValue);

   m_nCaptureDevice = SendDlgItemMessage(hWnd, IDC_VIDEODRIVER, CB_GETCURSEL, 0, 0);

   // Auflsung auswerten
   m_nDisplayMode = 0;

   GetDlgItemText(hWnd, IDC_DISPLAYMODE, pValue, sizeof(pValue));
   for(nZlr=0; nZlr<ANZAHL_AUFLOESUNG; nZlr++)
   {
      if(lstrcmp(pValue, sAufloesung[nZlr].pName) == 0)
      {
         m_nDisplayMode = nZlr;
         break;
      }
   }

   // Tuner
   m_nTuner = 0;

   GetDlgItemText(hWnd, IDC_TUNER, pValue, sizeof(pValue));
   for(nZlr=0; nZlr<ANZAHL_TUNER; nZlr++)
   {
      if(lstrcmp(pValue, sTuner[nZlr].pName) == 0)
      {
         m_nTuner = nZlr;
         break;
      }
   }

   // TVCard
   m_nTVCard = 0;

   GetDlgItemText(hWnd, IDC_TVCARD, pValue, sizeof(pValue));
   for(nZlr=0; nZlr<ANZAHL_TVCARD; nZlr++)
   {
      if(lstrcmp(pValue, sTVCard[nZlr].pName) == 0)
      {
         m_nTVCard = nZlr;
         break;
      }
   }

   if(BST_CHECKED == IsDlgButtonChecked(hWnd, IDC_STATISTIK))
      m_bStatistic = true;
   else
      m_bStatistic = false;

   if(BST_CHECKED == IsDlgButtonChecked(hWnd, IDC_BT848))
      m_bOptimierungBT = true;
   else
      m_bOptimierungBT = false;

   if(BST_CHECKED == IsDlgButtonChecked(hWnd, IDC_SECAM))
      m_bSecam = true;
   else
      m_bSecam = false;
   
   if(BST_CHECKED == IsDlgButtonChecked(hWnd, IDC_PRIORITY))
      m_bPriority = true;
   else
      m_bPriority = false;

   if(BST_CHECKED == IsDlgButtonChecked(hWnd, IDC_AUSTASTUNG))
      m_bAustastung = true;
   else
      m_bAustastung = false;

   if(BST_CHECKED == IsDlgButtonChecked(hWnd, IDC_PALPLUS))
      m_bPALplus = true;
   else
      m_bPALplus = false;

   if(BST_CHECKED == IsDlgButtonChecked(hWnd, IDC_SCHWARZE_ZEILE))
      m_bSchwarzeZeile = true;
   else
      m_bSchwarzeZeile = false;

	// Sound by Satan
   if(BST_CHECKED == IsDlgButtonChecked(hWnd, IDC_SOUND))
      m_bSound = true;
   else
      m_bSound = false;
	
   if(BST_CHECKED == IsDlgButtonChecked(hWnd, IDC_SOUNDMMX))
      m_bSoundMMX = true;
   else
      m_bSoundMMX = false;

   if(BST_CHECKED == IsDlgButtonChecked(hWnd, IDC_SOUNDFILTER))
      m_bSoundFilter = true;
   else
      m_bSoundFilter = false;


   return true;
}


void CKonfig::SelectString
(
   HWND        hWnd,
   int         nID,
   const char *pString
)
{
   int nIndex = SendDlgItemMessage(hWnd, nID, CB_FINDSTRINGEXACT, (WPARAM)-1, (LPARAM)(LPCSTR)pString);

   if(nIndex == CB_ERR)
      SendDlgItemMessage(hWnd, nID, CB_SETCURSEL, 0, 0);
   else
      SendDlgItemMessage(hWnd, nID, CB_SETCURSEL, nIndex, 0);
}


// Dialogelemente setzen
void CKonfig::SetDialogData
(
   HWND hWnd
)
{
   char pValue[80];

   SetDlgItemText(hWnd, IDC_VERSION, pVersion);

   sprintf(pValue, "%d", m_nTestZeilen);
   SetDlgItemText(hWnd, IDC_TESTZEILEN, pValue);

   sprintf(pValue, "%d", m_nErsteZeile);
   SetDlgItemText(hWnd, IDC_ERSTE_ZEILE, pValue);

   sprintf(pValue, "%d", m_nLetzteZeile);
   SetDlgItemText(hWnd, IDC_LETZTE_ZEILE, pValue);

   // Liste mit allen Capture Treibern in die Listbox schreiben
   for(int nCaptureDevice=0; nCaptureDevice<ANZAHL_DRIVERS; nCaptureDevice++)
   {
      char strDeviceName[80];
      char strDeviceVersion[80];

      if(capGetDriverDescription( nCaptureDevice,
                                  (LPSTR)strDeviceName,
                                  sizeof(strDeviceName),
                                  (LPSTR)strDeviceVersion,
                                  sizeof(strDeviceVersion)
                                )
        ) 
      {
         SendDlgItemMessage(hWnd, IDC_VIDEODRIVER, CB_ADDSTRING, 0, (LPARAM)strDeviceName);
      }
   }

   // Aktuellen Treiber selektieren
   if(CB_ERR == SendDlgItemMessage(hWnd, IDC_VIDEODRIVER, CB_SETCURSEL, m_nCaptureDevice, 0))
      SendDlgItemMessage(hWnd, IDC_VIDEODRIVER, CB_SETCURSEL, 0, 0);

   // Liste mit allen Ausgabeformaten in die Listbox schreiben
   for(int nDisplayMode=0; nDisplayMode<ANZAHL_AUFLOESUNG; nDisplayMode++)
   {
      // Wird die Auflsung untersttzt
      if(sAufloesung[nDisplayMode].bActive == false)
         continue;

      // Ist MMX vorhanden und erforderlich
      if( IsMMX() == false &&
          sAufloesung[nDisplayMode].bMMX == true
        )
         continue;

      // Ist ein Overlay vorhanden und erforderlich
      if( m_bOverlay == false &&
          sAufloesung[nDisplayMode].bOverlay == true
        )
         continue;

      SendDlgItemMessage(hWnd, IDC_DISPLAYMODE, CB_ADDSTRING, 0, (LPARAM)(LPCSTR)(sAufloesung[nDisplayMode].pName));
   }

   // Liste aller Tuner in die Listbox schreiben
   for(int nTuner=0; nTuner<ANZAHL_TUNER; nTuner++)
      SendDlgItemMessage(hWnd, IDC_TUNER, CB_ADDSTRING, 0, (LPARAM)(LPCSTR)(sTuner[nTuner].pName));

   // Liste aller TV-Karten in die Listbox schreiben
   for(int nTVCard=0; nTVCard<ANZAHL_TVCARD; nTVCard++)
      SendDlgItemMessage(hWnd, IDC_TVCARD, CB_ADDSTRING, 0, (LPARAM)(LPCSTR)(sTVCard[nTVCard].pName));

   // Aktuelles Ausgabeformat selektieren
   SelectString(hWnd, IDC_DISPLAYMODE, sAufloesung[m_nDisplayMode].pName);
   SelectString(hWnd, IDC_TUNER, sTuner[m_nTuner].pName);
   SelectString(hWnd, IDC_TVCARD, sTVCard[m_nTVCard].pName);

   CheckDlgButton(hWnd, IDC_STATISTIK, m_bStatistic);
   CheckDlgButton(hWnd, IDC_SECAM, m_bSecam);
   CheckDlgButton(hWnd, IDC_AUSTASTUNG, m_bAustastung);
   CheckDlgButton(hWnd, IDC_PALPLUS, m_bPALplus);
   CheckDlgButton(hWnd, IDC_PRIORITY, m_bPriority);
   CheckDlgButton(hWnd, IDC_SCHWARZE_ZEILE, m_bSchwarzeZeile);

   // Sound by Satan
   CheckDlgButton(hWnd, IDC_SOUND, m_bSound);
   CheckDlgButton(hWnd, IDC_SOUNDMMX, m_bSoundMMX);
   CheckDlgButton(hWnd, IDC_SOUNDFILTER, m_bSoundFilter);

   // OptimierungBT
   if(m_bEnableBT == false)
   {
      CheckDlgButton(hWnd, IDC_BT848, false);
      EnableWindow(GetDlgItem(hWnd, IDC_BT848), false);
      EnableWindow(GetDlgItem(hWnd, IDC_TUNER), false);
      EnableWindow(GetDlgItem(hWnd, IDC_TVCARD), false);
   }
   else
   {
      CheckDlgButton(hWnd, IDC_BT848, m_bOptimierungBT);
   }
}


BOOL CALLBACK CKonfig::KonfigDialog
(
   HWND     hWnd,
   UINT     uMessage,
   WPARAM   wParam,
   LPARAM   lParam
)
{
   switch(uMessage)
   {
      case WM_INITDIALOG:
		{
			CKonfig *pKonfig = (CKonfig*)lParam;

			SetProp(hWnd, pKonfigKlasse, pKonfig);

         pKonfig->ProfilLesen();
         pKonfig->SetDialogData(hWnd);

         if(pKonfig->m_bHideDialog == true)
            SendMessage(hWnd, WM_COMMAND, MAKEWPARAM(IDOK, BN_CLICKED), 0);

         return TRUE;
		}
      break;

      case WM_COMMAND:
         switch(LOWORD(wParam))
         {
            case IDC_PALPLUS:
               CheckDlgButton(hWnd, IDC_SCHWARZE_ZEILE, false);
            break;

            case IDC_SCHWARZE_ZEILE:
               CheckDlgButton(hWnd, IDC_PALPLUS, false);
            break;

            case IDC_SPEICHERN:
				{
					CKonfig *pKonfig = (CKonfig*)GetProp(hWnd, pKonfigKlasse);
			
               pKonfig->GetDialogData(hWnd);
               pKonfig->CheckParameter();
               pKonfig->ProfilSpeichern();

               return TRUE;
				}
            break;

            case IDOK:
				{
   	           CKonfig *pKonfig = (CKonfig*)GetProp(hWnd, pKonfigKlasse);

               pKonfig->GetDialogData(hWnd);
               pKonfig->CheckParameter();

               DebugString("MMX %d",           pKonfig->IsMMX()          );
               DebugString("Overlay %d",       pKonfig->m_bOverlay       );
               DebugString("EnableBT %d",      pKonfig->m_bEnableBT      );
               DebugString("Optimierung %d",   pKonfig->m_bOptimierungBT );
               DebugString("PALplus %d",       pKonfig->m_bPALplus       );
               DebugString("Priority %d",      pKonfig->m_bPriority      );
               DebugString("SchwarzeZeile %d", pKonfig->m_bSchwarzeZeile );
               DebugString("Statistic %d",     pKonfig->m_bStatistic     );
               DebugString("Austastung %d",    pKonfig->m_bAustastung    );
               DebugString("TestZeilen %d",    pKonfig->m_nTestZeilen    );
               DebugString("ErsteZeile %d",    pKonfig->m_nErsteZeile    );
               DebugString("LetzteZeile %d",   pKonfig->m_nLetzteZeile   );
               DebugString("Secam %d",         pKonfig->m_bSecam         );
               DebugString("Tuner %d",         pKonfig->m_nTuner         );
               DebugString("TVCard %d",        pKonfig->m_nTVCard        );
               DebugString("DisplayMode %d",   pKonfig->m_nDisplayMode   );
               DebugString("CaptureDevice %d", pKonfig->m_nCaptureDevice );
			   // Sound by Satan
			   DebugString("Sound %d",         pKonfig->m_bSound         );
			   DebugString("SoundMMX %d",      pKonfig->m_bSoundMMX      );
               DebugString("SoundFilter %d",   pKonfig->m_bSoundFilter   );


			   RemoveProp(hWnd, pKonfigKlasse);
               EndDialog(hWnd, LOWORD(wParam));

               return TRUE;
				}
            break;

            case IDCANCEL:
			   RemoveProp(hWnd, pKonfigKlasse);
               EndDialog(hWnd, LOWORD(wParam));

               return TRUE;
            break;
         }
      break;
   }

   return FALSE;
}
