#ifndef __KONFIG__
#define __KONFIG__


int const KEINE  = 0;
int const ERAZOR = 1;


#include "DirectDraw.h"


class CKonfig
{
   public:
      CKonfig
      (
         CDirectDraw *pDirectDraw
      );

      virtual ~CKonfig();

      int   DoModal(HINSTANCE, bool, bool);
      int   FarbeLesen();
      void  FarbeSpeichern(int);
      void  FormatSpeichern();
      int   HelligkeitLesen();
      void  HelligkeitSpeichern(int);
      bool  GetAustastung();
      int   GetCaptureDevice();
      DWORD GetCooperativeLevel();
      int   GetErsteZeile();
      bool  GetFensterMode();
      int   GetLetzteZeile();   
      bool  GetMMX();
      bool  GetOverlay();
      bool  GetPALplus();
      bool  GetPriority();
      bool  GetSchwarzeZeile();
      int   GetScreenWidth();
      int   GetScreenHeight();
      bool  GetInterpolation();
      bool  GetStatistic();
      int   GetTestZeilen();
      int   GetTVKarte();
      int   GetVideoWidth();
      int   GetVideoHeight();
      int   GetZeilenAusgabe();
      int   KanalLesen(int);
      void  KanalSpeichern(int, int);
      int   KontrastLesen();
      void  KontrastSpeichern(int);
      int   SetErsteZeile(int);
      int   SetLetzteZeile(int);

   private:
      void  CheckParameter();
      bool  GetDialogData(HWND);
      bool  GetProfileBool(const char*, bool);
      int   GetProfileInt(const char*, int);
      bool  IsMMX();
      void  SelectString(HWND, int, const char*);
      void  SetDialogData(HWND);
      void  SetProfileBool(const char*, const bool);
      void  SetProfileInt(const char*, const int);
      void  ProfilLesen();
      void  ProfilSpeichern();

      static BOOL CALLBACK KonfigDialog(HWND, UINT, WPARAM, LPARAM);

	    bool  m_bHideDialog;
      bool  m_bOverlay;
      bool  m_bEnableBT;
      bool  m_bPALplus;
      bool  m_bPriority;
      bool  m_bSchwarzeZeile;
      bool  m_bStatistic;
      bool  m_bAustastung;
  	  bool  m_bInterpolation;
	    bool  m_bMMX;
      int   m_nTestZeilen;
      int   m_nErsteZeile;
      int   m_nLetzteZeile;
      int   m_nTVCard;
      int   m_nDisplayMode;
      int   m_nCaptureDevice;
};

#endif
