#ifndef __KONFIG__
#define __KONFIG__


int const KEINE           = 0;
int const HAUPPAUGE_848   = 1;
int const HAUPPAUGE_878   = 2;
int const MIRO_PCTV       = 3;

int const TEMIC_PAL_B_G   = 0;
int const TEMIC_PAL_I     = 1;
int const PHILIPS_PAL_B_G = 2;
int const PHILIPS_PAL_I   = 3;
int const PHILIPS_SECAM   = 4;


#include "DirectDraw.h"


class CKonfig
{
   public:
      CKonfig
      (
         CDirectDraw *pDirectDraw
      );

      virtual ~CKonfig();

      int   DoModal(HINSTANCE, bool, bool);
      int   FarbeLesen();
      void  FarbeSpeichern(int);
      void  FormatSpeichern();
      int   HelligkeitLesen();
      void  HelligkeitSpeichern(int);
      bool  GetAustastung();
      int   GetCaptureDevice();
      DWORD GetCooperativeLevel();
      int   GetErsteZeile();
      bool  GetFensterMode();
      int   GetLetzteZeile();   
      bool  GetMMX();
      bool  GetOptimierungBT();
      bool  GetOverlay();
      bool  GetPALplus();
      bool  GetPriority();
      bool  GetSchwarzeZeile();
      int   GetScreenWidth();
      int   GetScreenHeight();
      bool  GetSecam();
      bool  GetStatistic();
      int   GetTestZeilen();
      int   GetTuner();
      int   GetTVKarte();
      int   GetVideoWidth();
      int   GetVideoHeight();
      int   GetZeilenAusgabe();
      int   KanalLesen(int);
      void  KanalSpeichern(int, int);
      int   KontrastLesen();
      void  KontrastSpeichern(int);
      int   SetErsteZeile(int);
      int   SetLetzteZeile(int);

	  // Sound by Satan
	  char  GetSoundMMX();
	  char  GetSoundFilter();
	  bool  GetSound();


   private:
      void  CheckParameter();
      bool  GetDialogData(HWND);
      bool  GetProfileBool(const char*, bool);
      int   GetProfileInt(const char*, int);
      bool  IsMMX();
      void  SelectString(HWND, int, const char*);
      void  SetDialogData(HWND);
      void  SetProfileBool(const char*, const bool);
      void  SetProfileInt(const char*, const int);
      void  ProfilLesen();
      void  ProfilSpeichern();

      static BOOL CALLBACK KonfigDialog(HWND, UINT, WPARAM, LPARAM);

      bool  m_bHideDialog;
      bool  m_bOverlay;
      bool  m_bEnableBT;
      bool  m_bOptimierungBT;
      bool  m_bPALplus;
      bool  m_bPriority;
      bool  m_bSchwarzeZeile;
      bool  m_bSecam;
      bool  m_bStatistic;
      bool  m_bAustastung;
      int   m_nTestZeilen;
      int   m_nErsteZeile;
      int   m_nLetzteZeile;
      int   m_nTuner;
      int   m_nTVCard;
      int   m_nDisplayMode;
      int   m_nCaptureDevice;
	  
	  // Sound by Satan
	  bool  m_bSound;
	  bool  m_bSoundMMX;
	  bool  m_bSoundFilter;

};

#endif
