//-------------------------------//
// NagraView.h   by:   KennyWood //
//-------------------------------//

#ifndef _NAGRAVIEW_H_
#define _NAGRAVIEW_H_

//-----------------------------------------------------------------------------

#include <windows.h>
#include <vfw.h>
#include "Global.h"

//-----------------------------------------------------------------------------

#define SAVEFIELDS  FALSE
#define LOADFRAMES  FALSE
#define SAVEFRAMES  FALSE
#define SAVEMOVIE   FALSE
#define ROUNDROBIN     20
#define DEBUGFILE   FALSE
#define SAVEPATH    "c:\\KennyWood"

#define   FIELDHEIGHT 288
#define BIFIELDHEIGHT (2 * FIELDHEIGHT)
#define MAXWIDTH      768

#define MAXCSCOPEUP   100
#define MAXCSCOPEDOWN 100

#define VMODES         11		// Total num of Video Modes (MUST be <= 11)

//-----------------------------------------------------------------------------
//
// GLOBAL WINDOWS VARIABLES
//
extern HINSTANCE   hInstance ;   // Application instance
extern HWND        hMainWnd ;    // The main window
extern HWND        hCapWnd ;     // The capture window associated with the main window
extern BITMAPINFO* DIB ;		 // A bitmap header with the characteristics of the cap. frame

//-----------------------------------------------------------------------------
//
// GLOBAL STATE CONFIGURABLE VARIABLES
//
extern BOOL fullScreen ;
extern BOOL color ;
extern BOOL decrypt ;
extern BOOL statistics ;
extern int  cinemascopeUp ;
extern int  cinemascopeDown ;
extern int  checkPairs ;
extern int  checkWidth ;
extern int  checkLevels ;
extern int  channel ;
extern int  card ;
extern int  priority ;
extern int  screenSize ;
extern BOOL showCheckArea ;
extern BOOL useSound ;
extern BOOL rgb565 ;
extern int  whichDriver ;
extern BOOL useBT848 ;
extern BOOL highQuality ;
extern int  interlace ;
extern BOOL phaseCorrector ;
extern int  palSecam ;
extern int  alwaysOnTop ;

extern int topAdjust ;

#define USEPAL   0
#define USESECAM 1

#define CHANNELS  17
#define CARDTYPES  8

extern volatile BOOL autoFindCScope ;

//-----------------------------------------------------------------------------
//
// GLOBAL STATE INTERNAL VARIABLES
//
extern int  displayWidth ;
extern int  displayHeight ;
extern int  displayBPP ;
extern int  captureWidth ;
extern BOOL started ;
extern BOOL canSound ;
extern int  numDrivers ;
extern int  minimum ;
extern int  kcnt ;
extern int  bestKey ;
extern BOOL haveBT848 ;
extern BOOL evenFrame ;
extern int  keyID ;
extern int  bindID ;

//-----------------------------------------------------------------------------

#if DEBUGFILE	
	extern FILE* debugFile ;
#endif

//-----------------------------------------------------------------------------

LRESULT CALLBACK VideoStreamCallback ( HWND hWnd , LPVIDEOHDR pVideoHeader ) ;

BOOL Setup_DoInitialSetup () ;
BOOL Setup_DoSpeedSetup   () ;
void Setup_DoHelp         () ;

void ChangeVideoMode () ;

void Setup_CheckParams  () ;
void Setup_SetINI       () ;
void Setup_GetINI       () ;
void Setup_MakeSetup    ( BOOL changeVideo , BOOL changePriority , BOOL changeBT ) ;
void Setup_UpdateMenus  () ;
void Setup_PrepareMenus () ;

//-----------------------------------------------------------------------------

#endif
