#ifndef __DECODE__
#define __DECODE__


// Anzahl der Zeilen pro Bild
const int ZEILENZAHL = 287;

// Gre der Paarindizes
const int INDEXSIZE = 20000;


class CSyster
{
   public:
      CSyster
      (
         int  nTestzeilen, 
         bool bSchwarzeZeile,
	    	 bool bInterpolation
      );

      virtual ~CSyster();

      bool FindeZeilenFolge
      (
         int **pLinesAddress,
         int  *pSortLines,
         int  *nPALplusData
      );

      bool FehlerStatus();

      virtual void DecodeColor
      (
         int **pLinesAddress,
         int  *pSortLines,
         int  *pDestination,
         int   nBreiteZiel,
         int   nErsteSichtbareZeile,
         int   nLetzteSichtbareZeile,
         bool  bBild,
         bool  bDecode,
         bool  bPhase
      ) = 0;

   protected:
      // Flag ob die Initialisierung geklappt hat
      bool  m_bError;
      bool  m_bPALplus;
      int   m_nBreiteQuelle;

   private:
      bool BaueIndex();
      void BerechnePermutation(int, int*);

      bool FindePALplus
      (
         int **pLinesAddress
      );

      void FindeSchwarzeZeilen
      (
         int **pLinesAddress
      );

      bool LeseIndexDatei();
      bool LeseKeyDatei();
      void PaarMerken(int);
      int  PaarBewerten(int);
      bool SchreibeIndexDatei();
      int  SucheKey();

      // Positon und Daten der PALplus Zeile
      int    m_nPALplusZeile;
      int    m_nPALplusData;

      // Anzal und Liste der ersten 32 Zeilen die schwarz sind
      int    m_nSchwarzeZeilen;
      bool   m_bSchwarzeZeile;
      bool   m_pSchwarzeZeile[32];
   
	    // Zeileninterpolation
  	  bool   m_bInterpolation;

      // Aus dieser Tabelle wird die Permutation errechnet
      char   m_pKey[256];

      // Jede Mglichkeit der Zeilenpermutation
      int    m_nPaarIndexAnzahl;
      int    m_nPaarIndex[INDEXSIZE];
      short *m_pKombinationen;
      int    m_nZeilenPaarKorrelation[INDEXSIZE];

      // Anzahl der Zeilen die getestet werden
      int    m_nTestzeilen;

      int    m_nAnzahlPaare;
      int   *m_nPaarNummer;
      int   *m_nPaarDanach;
      int   *m_nPaarDavor;
      int   *m_nPaarTreffer;
};

#endif