//----------------------------//
// Tables.h   by:   KennyWood //
//----------------------------//

#ifndef _TABLES_H_
#define _TABLES_H_

//-----------------------------------------------------------------------------

#include "Global.h"

//-----------------------------------------------------------------------------
//
// PRECOMPUTED NAGAVISION PERMUTATIONS
//
BYTE  S [ 256 ] ;	// Physical decoder's EPROM
SHORT P [ 288 ] ;	// Permutation function y' = P(y)

//-----------------------------------------------------------------------------
//
// NAGAVISION Y/YUV -> RGB15/16 CONVERSION
//
 USHORT YUV2RGBbpp [ 2 ][ 64 * 64 * 64 ] ;
 USHORT Y2RGBbpp   [ 2 ][ 256 ] ;
PUSHORT YUV2RGB ;
PUSHORT Y2RGB ;

//-----------------------------------------------------------------------------
//
// NAGAVISION PAL COLOR DEMODULATION
//
#define PALPERIOD 345
SHORT palDemod [ PALPERIOD * 4 * 4 ][ 64 ] ;

//-----------------------------------------------------------------------------
//
// PRECALCULATED CHECK PAIRS
//
int  num_combinations ;
int      combination [ 288 * 288 ] ;
int	combination_level   [ MAXCHECKPAIRS ] ;
int  checkPair [ 32768 ][ MAXCHECKPAIRS ] ;
BYTE testPixel [  288  ][ MAXCHECKWIDTH ] ;

//-----------------------------------------------------------------------------
//
// PRECALCULATED KEY SETS FOR EACH CHECK PAIR
//
struct
{
	int first ;
	int keys ;
} keys_directory [ 288 * 288 ] ;
USHORT keys_resource [ 2 * 1024 * 1024 ] ;   // This size is pseudoempirical.  It's enough for MAXCHECKPAIRS <= 64
int    keys_resource_cnt ;

//-----------------------------------------------------------------------------

#endif
