//---------------------------------------------------------------------------
// FileName     : drvclass.h
// Created      : 15/04/95
// Project      : Some projects
// Author       : Elli
// Contents     : Access to Windows NT/9x device driver
//                Loads and unloads a device driver.
// Note         : This program is free software; you can redistribute it
//                and/or modify it under the terms of the GNU General Public
//                License as published by the Free Software Foundation;
//                either version 2 of the License, or (at your option) any
//                later version.
//
//                This program is distributed in the hope that it will be useful,
//                but WITHOUT ANY WARRANTY; without even the implied warranty of
//                MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//                GNU General Public License for more details.
//
//                You should have received a copy of the GNU General Public
//                License along with this program; if not, write to the Free
//                Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
// History      :
//                V 1.00 initial version
//---------------------------------------------------------------------------

#if ! defined (__DRVCLASS_H)
#define __DRVCLASS_H

#if ! defined (__OBJWIN32)
#include <objwin32.h>
#endif

#include <winsvc.h>

#define DEVICE_PREFIX   "\\\\.\\"


//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
class CKernelDriver : public CWin32Object
 {
  public:
   CKernelDriver();
   ~CKernelDriver();

   virtual DWORD  start(
                        LPSTR pszDriverName,
                        LPSTR pszBinaryPathName
                       );

   virtual DWORD  start(LPSTR pszDriverName);

   virtual DWORD  stop (LPSTR pszDriverName, BOOL bRemove);
   virtual DWORD  stop (void);
   virtual DWORD  open (LPSTR pszDeviceName);
   virtual DWORD  close(void);
   virtual DWORD  read (
                        PVOID    pvBuffer,
                        DWORD    dwBufferSize,
                        LPDWORD  pdwBytesReading
                       );

   virtual DWORD  write(
                        PVOID    pvBuffer,
                        DWORD    dwBufferSize
                       );


   virtual DWORD  deviceControl(
                                DWORD   dwIOCommand,
                                LPVOID  pvInput,
                                DWORD   dwInputLength,
                                LPVOID  pvOutput,
                                DWORD   dwOutputLength,
                                LPDWORD pdwReturnedLength
                               );

   virtual DWORD  deviceControl(
                                DWORD   dwIOCommand,
                                LPVOID  pvInput,
                                DWORD   dwInputLength
                               );

  protected:
   virtual HANDLE openDevice(LPSTR pszDriverName);
   virtual HANDLE openFile  (LPSTR pszDriverName);

   DWORD         installDriver(
                               LPSTR  pszDriverName,
                               LPSTR  pszBinaryPathName
                              );

    void         removeDriver  (LPSTR pszDriverName);
    void         startDriver   (LPSTR pszDriverName);
    DWORD        stopDriver    (LPSTR pszDriverName);
    SC_HANDLE    openService   (LPSTR pszDriverName);
    BOOL         openSCM       (void);

  protected:
    SC_HANDLE   schSCManager;
    DWORD       serviceFlag;
    LPSTR       kdDriverName;
    HANDLE      kdFileHandle;
    BOOL        kdDeviceCreated;
    LPSTR       kdDOSDeviceName;
    BOOL        bWindows95;
 };

typedef CKernelDriver * PKernelDriver;


#endif



