//---------------------------------------------------------------------------
// FileName     : objwin32.h
// Created      : 15/04/95
// Project      : Some projects
// Author       : Elli
// Contents     : Object class root for WIN32 objects
// Note         : This program is free software; you can redistribute it
//                and/or modify it under the terms of the GNU General Public
//                License as published by the Free Software Foundation;
//                either version 2 of the License, or (at your option) any
//                later version.
//
//                This program is distributed in the hope that it will be useful,
//                but WITHOUT ANY WARRANTY; without even the implied warranty of
//                MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//                GNU General Public License for more details.
//
//                You should have received a copy of the GNU General Public
//                License along with this program; if not, write to the Free
//                Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
// History      :
//                V 1.00 initial version
//---------------------------------------------------------------------------

#if ! defined (__OBJWIN32_H)
#define __OBJWIN32_H

#if defined (_AFXDLL) || defined (_AFXEXT) || defined (F_USE_AFX)

#if ! defined (F_USE_AFX)
#define F_USE_AFX
#endif

#include <afxext.h>
#endif


#if defined (CLASSEXPORT)
#define _CLASSEXPORT     __declspec(dllexport)
#else
#define _CLASSEXPORT
#endif

#if ! defined (_WINDOWS_)
#include <windows.h>
#endif



class _CLASSEXPORT CWin32Object
 #if defined (F_USE_AFX)
  : public CObject
 #endif
 {
//  DECLARE_DYNAMIC( CWin32Object )

  public:
   CWin32Object()
    #if defined (F_USE_AFX)
     : CObject()
    #endif
    {
     dwLastError = ERROR_SUCCESS;
    }

           DWORD   getLastError(void);
           LPSTR   getErrorMessage(LPSTR pzsMessageBuffer);


  protected:

   virtual void     setError();
   virtual void     setError(DWORD dwError);

  protected:
   DWORD   dwLastError;
 };


inline DWORD
CWin32Object::getLastError(void)
 {
  return dwLastError;
 }

inline void
CWin32Object::setError(void)
 {
  dwLastError = ::GetLastError();
 }


inline void
CWin32Object::setError(DWORD dwError)
 {
  dwLastError = dwError;
 }


inline
LPSTR
CWin32Object::getErrorMessage(LPSTR pszMessageBuffer)
 {
  ::FormatMessage(
                  FORMAT_MESSAGE_FROM_SYSTEM,
                  NULL,
                  dwLastError,
                  MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
                  (LPTSTR) pszMessageBuffer,
                  128,                              // ???
                  NULL
                 );

  return pszMessageBuffer;
 }

#endif








