//---------------------------------------------------------------------------
// FileName     : hwio95.cpp
// Created      : 19/11/98
// Project      : Windows kernel device driver for hardware IO
// Author       : Elli
// Contents     : Driver main body
// Note         : This program is free software; you can redistribute it
//                and/or modify it under the terms of the GNU General Public
//                License as published by the Free Software Foundation;
//                either version 2 of the License, or (at your option) any
//                later version.
//
//                This program is distributed in the hope that it will be useful,
//                but WITHOUT ANY WARRANTY; without even the implied warranty of
//                MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//                GNU General Public License for more details.
//
//                You should have received a copy of the GNU General Public
//                License along with this program; if not, write to the Free
//                Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
// History      :
//                V 1.00 initial version
//---------------------------------------------------------------------------

#include <ioclass.h>
#include <debugout.h>

extern "C" {

DWORD _stdcall hwioW32DeviceIOControl(
                                      DWORD           dwService,
                                      DWORD           dwDDB,
                                      DWORD           hDevice,
                                      PDIOCPARAMETERS ioParam
                                     );


DWORD _stdcall hwioDynamicInit       (void);
DWORD _stdcall hwioDynamicExit       (void);
DWORD _stdcall hwioInitComplete      (void);

}


CIOAccessDevice * ioDevice;


//---------------------------------------------------------------------------
// Perform device IO control
//---------------------------------------------------------------------------
DWORD _stdcall
hwioW32DeviceIOControl(
                        DWORD           dwService,
                        DWORD           dwDDB,
                        DWORD           hDevice,
                        PDIOCPARAMETERS ioParam
                       )
 {
  debugOut(dbTrace,"hwioW32DeviceIOControl() %X",dwService);

  ioParam->dwIoControlCode = dwService;

  return ioDevice->deviceIOControl( ioParam );
 }

//---------------------------------------------------------------------------
// This function is called when the driver was loaded by Windows 95
// a static or dynamic vxd call your own startup code function from
// this function
//---------------------------------------------------------------------------
DWORD _stdcall
hwioDynamicInit(void)
 {
  debugInitialize("hwio95",0xFFFFFFFFL);

  debugOut(dbTrace,"hwioDynamicInit()");

  ioDevice = new CIOAccessDevice();

  return( ioDevice != 0);
 }


//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
DWORD _stdcall
hwioDynamicExit(void)
 {
  debugOut(dbTrace,"hwioDynamicExit()");

  delete ioDevice;

  return 1;
 }


//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
DWORD _stdcall
hwioInitComplete(void)
 {
  debugOut(dbTrace,"hwioInitComplete()");

  return 1;
 }


